//---------------------------------------------------------------------------
#include <vcl.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#pragma hdrstop

#include "Drcfg.h"
#include "printconf.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TDruckCFG *DruckCFG;
struct PrintConf conf;
//---------------------------------------------------------------------------
__fastcall TDruckCFG::TDruckCFG(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TDruckCFG::GetFont (TFont *f,struct FontData *fd)
{
   strcpy (fd->Name,f->Name.c_str ());
   fd->Size = f->Size;
   fd->Color = f->Color;
   fd->height = f->Height;
   fd->pitch = f->Pitch;
   GetFontStyle (f,&fd->Style);
}

void __fastcall TDruckCFG::AendernClick(TObject *Sender)
{
int r;
try
{

     if (PageControl->ActivePage == TabSheet1) FontDialog->Font = Panel->Font;
     else
     if (PageControl->ActivePage == TabSheet2) FontDialog->Font = Panel1->Font;
     else
     if (PageControl->ActivePage == TabSheet3) FontDialog->Font = Panel2->Font;
     else
     if (PageControl->ActivePage == TabSheet4) FontDialog->Font = Panel3->Font;
     else
     if (PageControl->ActivePage == TabSheet6) FontDialog->Font = Panel4->Font;
     r = FontDialog->Execute ();
}
catch (...)
{
   Application->MessageBox ("Kein Zugriff auf Druckerschriften","Fehler",MB_ICONERROR);
   return;
}
   if (r)
   {
      if (PageControl->ActivePage == TabSheet1)
      {
           Panel->Font = FontDialog->Font;
           GetFont (Panel->Font,&conf.Header1);
      } else
      if (PageControl->ActivePage == TabSheet2)
      {
           Panel1->Font = FontDialog->Font;
           GetFont (Panel1->Font,&conf.HeadLine);
      } else
      if (PageControl->ActivePage == TabSheet3)
      {
           Panel2->Font = FontDialog->Font;
           GetFont (Panel2->Font,&conf.Normal);
      } else
      if (PageControl->ActivePage == TabSheet4)
      {
           Panel3->Font = FontDialog->Font;
           GetFont (Panel3->Font,&conf.Bold);
      } else
       if (PageControl->ActivePage == TabSheet6)
      {
           Panel4->Font = FontDialog->Font;
           GetFont (Panel4->Font,&conf.Header2);
      }

   }
}
//---------------------------------------------------------------------------

void __fastcall TDruckCFG::AbbruchClick(TObject *Sender)
{
   Close ();
}
//---------------------------------------------------------------------------

void __fastcall TDruckCFG::SpeichernClick(TObject *Sender)
{
FILE *fp;

  fp = fopen ("druck.cfg","wb");
  if (!fp)
  {
     Application->MessageBox ("Druckkonfigurationsdatei kann nicht geffnet werden","Fehler",MB_OK | MB_ICONERROR);
     return;
  }

  conf.Top = atoi (M_or->Text.c_str ());
  conf.Left = atoi (M_lr->Text.c_str ());
  conf.Bottom = atoi (M_ur->Text.c_str ());
  conf.LS = atof (M_za->Text.c_str ());
  conf.Right = atof (M_rr->Text.c_str ());
  fwrite (&conf,1,sizeof (struct PrintConf),fp);
  fclose (fp);
}
//---------------------------------------------------------------------------

void SetDefaultWerte ()
{
     strcpy (conf.Header1.Name,"Arial");
     conf.Header1.Size = 18;
     conf.Header1.height = -24;
     memcpy (&conf.Header2,&conf.Header1,sizeof (FontData));
     strcpy (conf.HeadLine.Name,"Arial");
     conf.HeadLine.Size = 14;
     conf.HeadLine.height = -18;
     strcpy (conf.Normal.Name,"Arial");
     conf.Normal.Size = 10;
     conf.Normal.height = -14;
     strcpy (conf.Bold.Name,"Arial");
     conf.Bold.Size = 10;
     conf.Bold.height = -14;
     conf.Bold.Style = IS_FETT;

     conf.LS = 1.1;
     conf.Left = 50;
     conf.Top = 15;
     conf.Bottom = 15;
     conf.Right = 15;

}

void read_druckcfg ()
{
FILE *fp;
  fp = fopen ("druck.cfg","rb");
  if (!fp)
  {
     SetDefaultWerte ();
     return;
  }
  if (fread (&conf,sizeof (struct PrintConf),1,fp) != 1) SetDefaultWerte ();
  if (conf.LS < 1) conf.LS = 1.3;
  fclose (fp);
}


void __fastcall TDruckCFG::GetFontStyle (TFont *f,int *style)
{
   *style = 0;
   if (f->Style.Contains (fsBold))
   {
      *style = IS_FETT;
   }
   if (f->Style.Contains (fsItalic))
   {
      *style = *style | IS_ITALIC;
   }
   if (f->Style.Contains (fsUnderline)) *style = *style | IS_UNDERLINE;
}

void __fastcall TDruckCFG::SetNewFont (TFont *f,struct FontData *fd)
{
TFontStyles ts;
   f->Name = fd->Name;
   f->Size = fd->Size;
   f->Color = (TColor) fd->Color;
   f->Height = fd->height;
   f->Pitch = (TFontPitch) fd->pitch;
   ts.Clear ();
   if (fd->Style & IS_FETT)
   {
      ts << fsBold;
   }
   if (fd->Style & IS_ITALIC)
   {
       ts << fsItalic;
   }
   if (fd->Style & IS_UNDERLINE) ts << fsUnderline;
   f->Style = ts;
}



void __fastcall TDruckCFG::SetFont(int i)
{
    switch (i)
    {
       case 0:
          SetNewFont (Panel->Font,&conf.Header1);
       break;
       case 1:
          SetNewFont (Panel1->Font,&conf.HeadLine);
       break;
       case 2:
          SetNewFont (Panel2->Font,&conf.Normal);
       break;
       case 3:
         SetNewFont (Panel3->Font,&conf.Bold);
       break;
       case 4:
         SetNewFont (Panel4->Font,&conf.Header2);

    }
}
//---------------------------------------------------------------------------




void __fastcall TDruckCFG::PageControlChange(TObject *Sender)
{
   if (PageControl->ActivePage == TabSheet5) Aendern->Enabled = FALSE;
   else Aendern->Enabled = TRUE;
}
//---------------------------------------------------------------------------


void __fastcall TDruckCFG::HilfeClick(TObject *Sender)
{
Application->HelpContext (5095);
}
//---------------------------------------------------------------------------

void __fastcall TDruckCFG::FormResize(TObject *Sender)
{
int xx,yy;
    xx = Width - old_x;
    yy = Height - old_y;
    PageControl->Width = PageControl->Width + xx;
    PageControl->Height = PageControl->Height + yy;
    TabSheet1->Width = TabSheet1->Width + xx;
    TabSheet1->Height = TabSheet1->Height + yy;
    TabSheet1->Width = TabSheet1->Width + xx;

    TabSheet2->Height = TabSheet2->Height + yy;
    TabSheet2->Width = TabSheet2->Width + xx;

    TabSheet3->Height = TabSheet3->Height + yy;
    TabSheet3->Width = TabSheet3->Width + xx;

    TabSheet4->Height = TabSheet4->Height + yy;
    TabSheet4->Width = TabSheet4->Width + xx;

    TabSheet5->Height = TabSheet5->Height + yy;
    TabSheet5->Width = TabSheet5->Width + xx;

    TabSheet6->Height = TabSheet6->Height + yy;
    TabSheet6->Width = TabSheet6->Width + xx;

    yy = Speichern->Top + yy;
    Speichern->Top = yy;
    Abbruch->Top = yy;
    Aendern->Top = yy;

    old_x = Width;
    old_y = Height;
}
//---------------------------------------------------------------------------

void __fastcall TDruckCFG::FormCreate(TObject *Sender)
{
int i;
   old_x = Width;
   old_y = Height;
   read_druckcfg ();
   for (i=0;i < 5;i++) SetFont (i);
   M_za->Text = AnsiString (conf.LS);
   M_lr->Text = AnsiString (conf.Left);
   M_or->Text = AnsiString (conf.Top);
   M_ur->Text = AnsiString (conf.Bottom);
   M_rr->Text = AnsiString (conf.Right);
}
//---------------------------------------------------------------------------

